package com.sun.java.util.jar.pack;

import java.util.ListIterator;
import java.util.Collection;
import java.util.Iterator;
import java.util.ArrayList;
import java.util.List;

final class FixedList<E> implements List<E>
{
    private final ArrayList<E> flist;
    
    protected FixedList(int initialCapacity) {
        this.flist = new ArrayList(initialCapacity);
        for (int i = 0; i < initialCapacity; ++i) {
            this.flist.add(null);
        }
    }
    
    @Override
    public int size() {
        return this.flist.size();
    }
    
    @Override
    public boolean isEmpty() {
        return this.flist.isEmpty();
    }
    
    @Override
    public boolean contains(Object o) {
        return this.flist.contains(o);
    }
    
    @Override
    public Iterator<E> iterator() {
        return this.flist.iterator();
    }
    
    @Override
    public Object[] toArray() {
        return this.flist.toArray();
    }
    
    @Override
    public <T> T[] toArray(T[] a) {
        return this.flist.toArray(a);
    }
    
    @Override
    public boolean add(E e) throws UnsupportedOperationException {
        throw new UnsupportedOperationException("operation not permitted");
    }
    
    @Override
    public boolean remove(Object o) throws UnsupportedOperationException {
        throw new UnsupportedOperationException("operation not permitted");
    }
    
    @Override
    public boolean containsAll(Collection<?> c) {
        return this.flist.containsAll(c);
    }
    
    @Override
    public boolean addAll(Collection<? extends E> collection) throws UnsupportedOperationException {
        throw new UnsupportedOperationException("operation not permitted");
    }
    
    @Override
    public boolean addAll(int n, Collection<? extends E> collection) throws UnsupportedOperationException {
        throw new UnsupportedOperationException("operation not permitted");
    }
    
    @Override
    public boolean removeAll(Collection<?> collection) throws UnsupportedOperationException {
        throw new UnsupportedOperationException("operation not permitted");
    }
    
    @Override
    public boolean retainAll(Collection<?> collection) throws UnsupportedOperationException {
        throw new UnsupportedOperationException("operation not permitted");
    }
    
    @Override
    public void clear() throws UnsupportedOperationException {
        throw new UnsupportedOperationException("operation not permitted");
    }
    
    @Override
    public E get(int index) {
        return this.flist.get(index);
    }
    
    @Override
    public E set(int index, E element) {
        return this.flist.set(index, element);
    }
    
    @Override
    public void add(int n, E e) throws UnsupportedOperationException {
        throw new UnsupportedOperationException("operation not permitted");
    }
    
    @Override
    public E remove(int n) throws UnsupportedOperationException {
        throw new UnsupportedOperationException("operation not permitted");
    }
    
    @Override
    public int indexOf(Object o) {
        return this.flist.indexOf(o);
    }
    
    @Override
    public int lastIndexOf(Object o) {
        return this.flist.lastIndexOf(o);
    }
    
    @Override
    public ListIterator<E> listIterator() {
        return this.flist.listIterator();
    }
    
    @Override
    public ListIterator<E> listIterator(int index) {
        return this.flist.listIterator(index);
    }
    
    @Override
    public List<E> subList(int fromIndex, int toIndex) {
        return this.flist.subList(fromIndex, toIndex);
    }
    
    @Override
    public String toString() {
        return "FixedList{plist=" + this.flist + 125;
    }
}
